// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from rcss3d_agent_msgs:msg/Beam.idl
// generated code does not contain a copyright notice

#ifndef RCSS3D_AGENT_MSGS__MSG__DETAIL__BEAM__STRUCT_H_
#define RCSS3D_AGENT_MSGS__MSG__DETAIL__BEAM__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Struct defined in msg/Beam in the package rcss3d_agent_msgs.
/**
  * The beam effector allows a player to position itself on the field before the start of each half.
  * The x and y coordinates define the position on the field with respect to the field's coordinate
  * system, where (0,0) is the absolute center of the field. The rot specifies the facing angle of
  * the player. Zero points to positive x-axis, 90 to positive y-axis.
 */
typedef struct rcss3d_agent_msgs__msg__Beam
{
  /// metres
  double x;
  /// metres
  double y;
  /// degrees
  double rot;
} rcss3d_agent_msgs__msg__Beam;

// Struct for a sequence of rcss3d_agent_msgs__msg__Beam.
typedef struct rcss3d_agent_msgs__msg__Beam__Sequence
{
  rcss3d_agent_msgs__msg__Beam * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rcss3d_agent_msgs__msg__Beam__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // RCSS3D_AGENT_MSGS__MSG__DETAIL__BEAM__STRUCT_H_
