// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from rcss3d_agent_msgs:msg/Effector.idl
// generated code does not contain a copyright notice

#ifndef RCSS3D_AGENT_MSGS__MSG__DETAIL__EFFECTOR__STRUCT_H_
#define RCSS3D_AGENT_MSGS__MSG__DETAIL__EFFECTOR__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'hinge_joint_vels'
#include "rcss3d_agent_msgs/msg/detail/hinge_joint_vel__struct.h"
// Member 'universal_joint_vels'
#include "rcss3d_agent_msgs/msg/detail/universal_joint_vel__struct.h"
// Member 'beams'
#include "rcss3d_agent_msgs/msg/detail/beam__struct.h"
// Member 'says'
#include "rcss3d_agent_msgs/msg/detail/say__struct.h"

/// Struct defined in msg/Effector in the package rcss3d_agent_msgs.
/**
  * Effectors allow agents to perform actions within the simulation. Agents control them by
  * sending messages to the server, and the server changes the game state accordingly.
  * Effectors are the logical dual of perceptors.
  * Details of each message type are explained in each msg file.
 */
typedef struct rcss3d_agent_msgs__msg__Effector
{
  rcss3d_agent_msgs__msg__HingeJointVel__Sequence hinge_joint_vels;
  rcss3d_agent_msgs__msg__UniversalJointVel__Sequence universal_joint_vels;
  rcss3d_agent_msgs__msg__Beam__Sequence beams;
  rcss3d_agent_msgs__msg__Say__Sequence says;
} rcss3d_agent_msgs__msg__Effector;

// Struct for a sequence of rcss3d_agent_msgs__msg__Effector.
typedef struct rcss3d_agent_msgs__msg__Effector__Sequence
{
  rcss3d_agent_msgs__msg__Effector * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rcss3d_agent_msgs__msg__Effector__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // RCSS3D_AGENT_MSGS__MSG__DETAIL__EFFECTOR__STRUCT_H_
