// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rcss3d_agent_msgs:msg/Hear.idl
// generated code does not contain a copyright notice
#include "rcss3d_agent_msgs/msg/detail/hear__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `team`
// Member `message`
#include "rosidl_runtime_c/string_functions.h"
// Member `direction`
#include "rosidl_runtime_c/primitives_sequence_functions.h"

bool
rcss3d_agent_msgs__msg__Hear__init(rcss3d_agent_msgs__msg__Hear * msg)
{
  if (!msg) {
    return false;
  }
  // team
  if (!rosidl_runtime_c__String__init(&msg->team)) {
    rcss3d_agent_msgs__msg__Hear__fini(msg);
    return false;
  }
  // time
  // self
  // direction
  if (!rosidl_runtime_c__float__Sequence__init(&msg->direction, 0)) {
    rcss3d_agent_msgs__msg__Hear__fini(msg);
    return false;
  }
  // message
  if (!rosidl_runtime_c__String__init(&msg->message)) {
    rcss3d_agent_msgs__msg__Hear__fini(msg);
    return false;
  }
  return true;
}

void
rcss3d_agent_msgs__msg__Hear__fini(rcss3d_agent_msgs__msg__Hear * msg)
{
  if (!msg) {
    return;
  }
  // team
  rosidl_runtime_c__String__fini(&msg->team);
  // time
  // self
  // direction
  rosidl_runtime_c__float__Sequence__fini(&msg->direction);
  // message
  rosidl_runtime_c__String__fini(&msg->message);
}

bool
rcss3d_agent_msgs__msg__Hear__are_equal(const rcss3d_agent_msgs__msg__Hear * lhs, const rcss3d_agent_msgs__msg__Hear * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // team
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->team), &(rhs->team)))
  {
    return false;
  }
  // time
  if (lhs->time != rhs->time) {
    return false;
  }
  // self
  if (lhs->self != rhs->self) {
    return false;
  }
  // direction
  if (!rosidl_runtime_c__float__Sequence__are_equal(
      &(lhs->direction), &(rhs->direction)))
  {
    return false;
  }
  // message
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->message), &(rhs->message)))
  {
    return false;
  }
  return true;
}

bool
rcss3d_agent_msgs__msg__Hear__copy(
  const rcss3d_agent_msgs__msg__Hear * input,
  rcss3d_agent_msgs__msg__Hear * output)
{
  if (!input || !output) {
    return false;
  }
  // team
  if (!rosidl_runtime_c__String__copy(
      &(input->team), &(output->team)))
  {
    return false;
  }
  // time
  output->time = input->time;
  // self
  output->self = input->self;
  // direction
  if (!rosidl_runtime_c__float__Sequence__copy(
      &(input->direction), &(output->direction)))
  {
    return false;
  }
  // message
  if (!rosidl_runtime_c__String__copy(
      &(input->message), &(output->message)))
  {
    return false;
  }
  return true;
}

rcss3d_agent_msgs__msg__Hear *
rcss3d_agent_msgs__msg__Hear__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rcss3d_agent_msgs__msg__Hear * msg = (rcss3d_agent_msgs__msg__Hear *)allocator.allocate(sizeof(rcss3d_agent_msgs__msg__Hear), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rcss3d_agent_msgs__msg__Hear));
  bool success = rcss3d_agent_msgs__msg__Hear__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rcss3d_agent_msgs__msg__Hear__destroy(rcss3d_agent_msgs__msg__Hear * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rcss3d_agent_msgs__msg__Hear__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rcss3d_agent_msgs__msg__Hear__Sequence__init(rcss3d_agent_msgs__msg__Hear__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rcss3d_agent_msgs__msg__Hear * data = NULL;

  if (size) {
    data = (rcss3d_agent_msgs__msg__Hear *)allocator.zero_allocate(size, sizeof(rcss3d_agent_msgs__msg__Hear), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rcss3d_agent_msgs__msg__Hear__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rcss3d_agent_msgs__msg__Hear__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rcss3d_agent_msgs__msg__Hear__Sequence__fini(rcss3d_agent_msgs__msg__Hear__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rcss3d_agent_msgs__msg__Hear__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rcss3d_agent_msgs__msg__Hear__Sequence *
rcss3d_agent_msgs__msg__Hear__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rcss3d_agent_msgs__msg__Hear__Sequence * array = (rcss3d_agent_msgs__msg__Hear__Sequence *)allocator.allocate(sizeof(rcss3d_agent_msgs__msg__Hear__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rcss3d_agent_msgs__msg__Hear__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rcss3d_agent_msgs__msg__Hear__Sequence__destroy(rcss3d_agent_msgs__msg__Hear__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rcss3d_agent_msgs__msg__Hear__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rcss3d_agent_msgs__msg__Hear__Sequence__are_equal(const rcss3d_agent_msgs__msg__Hear__Sequence * lhs, const rcss3d_agent_msgs__msg__Hear__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rcss3d_agent_msgs__msg__Hear__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rcss3d_agent_msgs__msg__Hear__Sequence__copy(
  const rcss3d_agent_msgs__msg__Hear__Sequence * input,
  rcss3d_agent_msgs__msg__Hear__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rcss3d_agent_msgs__msg__Hear);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    rcss3d_agent_msgs__msg__Hear * data =
      (rcss3d_agent_msgs__msg__Hear *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rcss3d_agent_msgs__msg__Hear__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          rcss3d_agent_msgs__msg__Hear__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rcss3d_agent_msgs__msg__Hear__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
