// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rcss3d_agent_msgs:msg/Player.idl
// generated code does not contain a copyright notice
#include "rcss3d_agent_msgs/msg/detail/player__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `team`
#include "rosidl_runtime_c/string_functions.h"
// Member `head`
// Member `rlowerarm`
// Member `llowerarm`
// Member `rfoot`
// Member `lfoot`
#include "rcss3d_agent_msgs/msg/detail/spherical__functions.h"

bool
rcss3d_agent_msgs__msg__Player__init(rcss3d_agent_msgs__msg__Player * msg)
{
  if (!msg) {
    return false;
  }
  // team
  if (!rosidl_runtime_c__String__init(&msg->team)) {
    rcss3d_agent_msgs__msg__Player__fini(msg);
    return false;
  }
  // id
  // head
  if (!rcss3d_agent_msgs__msg__Spherical__Sequence__init(&msg->head, 0)) {
    rcss3d_agent_msgs__msg__Player__fini(msg);
    return false;
  }
  // rlowerarm
  if (!rcss3d_agent_msgs__msg__Spherical__Sequence__init(&msg->rlowerarm, 0)) {
    rcss3d_agent_msgs__msg__Player__fini(msg);
    return false;
  }
  // llowerarm
  if (!rcss3d_agent_msgs__msg__Spherical__Sequence__init(&msg->llowerarm, 0)) {
    rcss3d_agent_msgs__msg__Player__fini(msg);
    return false;
  }
  // rfoot
  if (!rcss3d_agent_msgs__msg__Spherical__Sequence__init(&msg->rfoot, 0)) {
    rcss3d_agent_msgs__msg__Player__fini(msg);
    return false;
  }
  // lfoot
  if (!rcss3d_agent_msgs__msg__Spherical__Sequence__init(&msg->lfoot, 0)) {
    rcss3d_agent_msgs__msg__Player__fini(msg);
    return false;
  }
  return true;
}

void
rcss3d_agent_msgs__msg__Player__fini(rcss3d_agent_msgs__msg__Player * msg)
{
  if (!msg) {
    return;
  }
  // team
  rosidl_runtime_c__String__fini(&msg->team);
  // id
  // head
  rcss3d_agent_msgs__msg__Spherical__Sequence__fini(&msg->head);
  // rlowerarm
  rcss3d_agent_msgs__msg__Spherical__Sequence__fini(&msg->rlowerarm);
  // llowerarm
  rcss3d_agent_msgs__msg__Spherical__Sequence__fini(&msg->llowerarm);
  // rfoot
  rcss3d_agent_msgs__msg__Spherical__Sequence__fini(&msg->rfoot);
  // lfoot
  rcss3d_agent_msgs__msg__Spherical__Sequence__fini(&msg->lfoot);
}

bool
rcss3d_agent_msgs__msg__Player__are_equal(const rcss3d_agent_msgs__msg__Player * lhs, const rcss3d_agent_msgs__msg__Player * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // team
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->team), &(rhs->team)))
  {
    return false;
  }
  // id
  if (lhs->id != rhs->id) {
    return false;
  }
  // head
  if (!rcss3d_agent_msgs__msg__Spherical__Sequence__are_equal(
      &(lhs->head), &(rhs->head)))
  {
    return false;
  }
  // rlowerarm
  if (!rcss3d_agent_msgs__msg__Spherical__Sequence__are_equal(
      &(lhs->rlowerarm), &(rhs->rlowerarm)))
  {
    return false;
  }
  // llowerarm
  if (!rcss3d_agent_msgs__msg__Spherical__Sequence__are_equal(
      &(lhs->llowerarm), &(rhs->llowerarm)))
  {
    return false;
  }
  // rfoot
  if (!rcss3d_agent_msgs__msg__Spherical__Sequence__are_equal(
      &(lhs->rfoot), &(rhs->rfoot)))
  {
    return false;
  }
  // lfoot
  if (!rcss3d_agent_msgs__msg__Spherical__Sequence__are_equal(
      &(lhs->lfoot), &(rhs->lfoot)))
  {
    return false;
  }
  return true;
}

bool
rcss3d_agent_msgs__msg__Player__copy(
  const rcss3d_agent_msgs__msg__Player * input,
  rcss3d_agent_msgs__msg__Player * output)
{
  if (!input || !output) {
    return false;
  }
  // team
  if (!rosidl_runtime_c__String__copy(
      &(input->team), &(output->team)))
  {
    return false;
  }
  // id
  output->id = input->id;
  // head
  if (!rcss3d_agent_msgs__msg__Spherical__Sequence__copy(
      &(input->head), &(output->head)))
  {
    return false;
  }
  // rlowerarm
  if (!rcss3d_agent_msgs__msg__Spherical__Sequence__copy(
      &(input->rlowerarm), &(output->rlowerarm)))
  {
    return false;
  }
  // llowerarm
  if (!rcss3d_agent_msgs__msg__Spherical__Sequence__copy(
      &(input->llowerarm), &(output->llowerarm)))
  {
    return false;
  }
  // rfoot
  if (!rcss3d_agent_msgs__msg__Spherical__Sequence__copy(
      &(input->rfoot), &(output->rfoot)))
  {
    return false;
  }
  // lfoot
  if (!rcss3d_agent_msgs__msg__Spherical__Sequence__copy(
      &(input->lfoot), &(output->lfoot)))
  {
    return false;
  }
  return true;
}

rcss3d_agent_msgs__msg__Player *
rcss3d_agent_msgs__msg__Player__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rcss3d_agent_msgs__msg__Player * msg = (rcss3d_agent_msgs__msg__Player *)allocator.allocate(sizeof(rcss3d_agent_msgs__msg__Player), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rcss3d_agent_msgs__msg__Player));
  bool success = rcss3d_agent_msgs__msg__Player__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rcss3d_agent_msgs__msg__Player__destroy(rcss3d_agent_msgs__msg__Player * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rcss3d_agent_msgs__msg__Player__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rcss3d_agent_msgs__msg__Player__Sequence__init(rcss3d_agent_msgs__msg__Player__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rcss3d_agent_msgs__msg__Player * data = NULL;

  if (size) {
    data = (rcss3d_agent_msgs__msg__Player *)allocator.zero_allocate(size, sizeof(rcss3d_agent_msgs__msg__Player), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rcss3d_agent_msgs__msg__Player__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rcss3d_agent_msgs__msg__Player__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rcss3d_agent_msgs__msg__Player__Sequence__fini(rcss3d_agent_msgs__msg__Player__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rcss3d_agent_msgs__msg__Player__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rcss3d_agent_msgs__msg__Player__Sequence *
rcss3d_agent_msgs__msg__Player__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rcss3d_agent_msgs__msg__Player__Sequence * array = (rcss3d_agent_msgs__msg__Player__Sequence *)allocator.allocate(sizeof(rcss3d_agent_msgs__msg__Player__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rcss3d_agent_msgs__msg__Player__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rcss3d_agent_msgs__msg__Player__Sequence__destroy(rcss3d_agent_msgs__msg__Player__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rcss3d_agent_msgs__msg__Player__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rcss3d_agent_msgs__msg__Player__Sequence__are_equal(const rcss3d_agent_msgs__msg__Player__Sequence * lhs, const rcss3d_agent_msgs__msg__Player__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rcss3d_agent_msgs__msg__Player__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rcss3d_agent_msgs__msg__Player__Sequence__copy(
  const rcss3d_agent_msgs__msg__Player__Sequence * input,
  rcss3d_agent_msgs__msg__Player__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rcss3d_agent_msgs__msg__Player);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    rcss3d_agent_msgs__msg__Player * data =
      (rcss3d_agent_msgs__msg__Player *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rcss3d_agent_msgs__msg__Player__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          rcss3d_agent_msgs__msg__Player__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rcss3d_agent_msgs__msg__Player__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
