// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from rcss3d_agent_msgs:msg/Player.idl
// generated code does not contain a copyright notice

#ifndef RCSS3D_AGENT_MSGS__MSG__DETAIL__PLAYER__STRUCT_H_
#define RCSS3D_AGENT_MSGS__MSG__DETAIL__PLAYER__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'team'
#include "rosidl_runtime_c/string.h"
// Member 'head'
// Member 'rlowerarm'
// Member 'llowerarm'
// Member 'rfoot'
// Member 'lfoot'
#include "rcss3d_agent_msgs/msg/detail/spherical__struct.h"

// constants for array fields with an upper bound
// head
enum
{
  rcss3d_agent_msgs__msg__Player__head__MAX_SIZE = 1
};
// rlowerarm
enum
{
  rcss3d_agent_msgs__msg__Player__rlowerarm__MAX_SIZE = 1
};
// llowerarm
enum
{
  rcss3d_agent_msgs__msg__Player__llowerarm__MAX_SIZE = 1
};
// rfoot
enum
{
  rcss3d_agent_msgs__msg__Player__rfoot__MAX_SIZE = 1
};
// lfoot
enum
{
  rcss3d_agent_msgs__msg__Player__lfoot__MAX_SIZE = 1
};

/// Struct defined in msg/Player in the package rcss3d_agent_msgs.
/**
  * An observed player is described through the name of it's team, the player number and one or more
  * position vectors to different body parts.
 */
typedef struct rcss3d_agent_msgs__msg__Player
{
  /// The player number of the seen player
  rosidl_runtime_c__String team;
  /// The player number of the seen player
  int32_t id;
  /// Observation of head
  rcss3d_agent_msgs__msg__Spherical__Sequence head;
  /// Observation of right lower arm
  rcss3d_agent_msgs__msg__Spherical__Sequence rlowerarm;
  /// Observation of left lower arm
  rcss3d_agent_msgs__msg__Spherical__Sequence llowerarm;
  /// Observation of right foot
  rcss3d_agent_msgs__msg__Spherical__Sequence rfoot;
  /// Observation of left foot
  rcss3d_agent_msgs__msg__Spherical__Sequence lfoot;
} rcss3d_agent_msgs__msg__Player;

// Struct for a sequence of rcss3d_agent_msgs__msg__Player.
typedef struct rcss3d_agent_msgs__msg__Player__Sequence
{
  rcss3d_agent_msgs__msg__Player * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rcss3d_agent_msgs__msg__Player__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // RCSS3D_AGENT_MSGS__MSG__DETAIL__PLAYER__STRUCT_H_
