// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rcss3d_agent_msgs:msg/UniversalJointPos.idl
// generated code does not contain a copyright notice

#ifndef RCSS3D_AGENT_MSGS__MSG__DETAIL__UNIVERSAL_JOINT_POS__STRUCT_HPP_
#define RCSS3D_AGENT_MSGS__MSG__DETAIL__UNIVERSAL_JOINT_POS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__rcss3d_agent_msgs__msg__UniversalJointPos __attribute__((deprecated))
#else
# define DEPRECATED__rcss3d_agent_msgs__msg__UniversalJointPos __declspec(deprecated)
#endif

namespace rcss3d_agent_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct UniversalJointPos_
{
  using Type = UniversalJointPos_<ContainerAllocator>;

  explicit UniversalJointPos_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->name = "";
      this->ax1 = 0.0f;
      this->ax2 = 0.0f;
    }
  }

  explicit UniversalJointPos_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : name(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->name = "";
      this->ax1 = 0.0f;
      this->ax2 = 0.0f;
    }
  }

  // field types and members
  using _name_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _name_type name;
  using _ax1_type =
    float;
  _ax1_type ax1;
  using _ax2_type =
    float;
  _ax2_type ax2;

  // setters for named parameter idiom
  Type & set__name(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->name = _arg;
    return *this;
  }
  Type & set__ax1(
    const float & _arg)
  {
    this->ax1 = _arg;
    return *this;
  }
  Type & set__ax2(
    const float & _arg)
  {
    this->ax2 = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rcss3d_agent_msgs::msg::UniversalJointPos_<ContainerAllocator> *;
  using ConstRawPtr =
    const rcss3d_agent_msgs::msg::UniversalJointPos_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rcss3d_agent_msgs::msg::UniversalJointPos_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rcss3d_agent_msgs::msg::UniversalJointPos_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rcss3d_agent_msgs::msg::UniversalJointPos_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rcss3d_agent_msgs::msg::UniversalJointPos_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rcss3d_agent_msgs::msg::UniversalJointPos_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rcss3d_agent_msgs::msg::UniversalJointPos_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rcss3d_agent_msgs::msg::UniversalJointPos_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rcss3d_agent_msgs::msg::UniversalJointPos_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rcss3d_agent_msgs__msg__UniversalJointPos
    std::shared_ptr<rcss3d_agent_msgs::msg::UniversalJointPos_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rcss3d_agent_msgs__msg__UniversalJointPos
    std::shared_ptr<rcss3d_agent_msgs::msg::UniversalJointPos_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const UniversalJointPos_ & other) const
  {
    if (this->name != other.name) {
      return false;
    }
    if (this->ax1 != other.ax1) {
      return false;
    }
    if (this->ax2 != other.ax2) {
      return false;
    }
    return true;
  }
  bool operator!=(const UniversalJointPos_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct UniversalJointPos_

// alias to use template instance with default allocator
using UniversalJointPos =
  rcss3d_agent_msgs::msg::UniversalJointPos_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace rcss3d_agent_msgs

#endif  // RCSS3D_AGENT_MSGS__MSG__DETAIL__UNIVERSAL_JOINT_POS__STRUCT_HPP_
